.install_requirements: &install_requirements
  - python -V
  - pip install -r requirements.txt
  - cd source

# отключено в связи с невозможностью запуска приёмочных тестов на gitlab (см. далее).

#.setup_chromedriver: &setup_chromedriver
#  - wget https://chromedriver.storage.googleapis.com/79.0.3945.36/chromedriver_linux64.zip
#  - unzip chromedriver_linux64.zip
#  - chmod +x chromedriver

image: python:3.6

stages:
  - unit_test
  - acc_test

cache:
  paths:
    - ~/.cache/pip/

run_unit_test:
  before_script:
    - *install_requirements
  stage: unit_test
  script: python manage.py test  --exclude-tag ignore --settings=main.settings_test

# Не работает, т.к. на данный момент gitlab не поддерживает создание нормальной связи
# между контейнерами сервиса и главным контейнером, и использует --link от главного к сервисам:
# т.е. главный имеет доступ к контейнерам сервисов, а они обратно - доступа не имеют.
# в свою очередь это значит, что браузер в контейнере selenium/standalone-chrome не может подключиться
# к серверу приложения, запущенному в главном, по любому url.
# https://gitlab.com/gitlab-org/gitlab-runner/issues/2127
# https://gitlab.com/gitlab-org/gitlab-runner/issues/1042

# Чтобы выполнять приёмочные тесты, нужно либо предварительно выполнить поставку на удалённый
# демо/тестовый сервер с известным адресом, и обращаться к нему, либо использовать сложные пути обхода,
# н-р, https://gitlab.com/MadLittleMods/gitlab-ci-access-main-container-from-service-container,
# включающие создание собственного контейнера и использование докера в докере (dind).

#run_acc_test:
#  stage: acc_test
#  before_script:
#    - *install_requirements
#    - *setup_chromedriver
#  variables:
#    REMOTE_CHROME_URL: "http://selenium__standalone-chrome:4444/wd/hub"
#    SITE_BASE_URL: "http://some-server:8000/"  # здесь должен быть url вашего сервера
#    USE_VENV: 0
#  services:
#    - selenium/standalone-chrome
#  script: python manage.py behave --settings=main.settings_test
